Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 859)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 861)
@@ -4,5 +4,6 @@
 ! Current revisions:
 ! -----------------
-!
+! Check for topography and ws-scheme removed.
+! Check for loop_optimization = 'vector' and ws-scheme removed.
 !
 ! Former revisions:
@@ -456,8 +457,9 @@
     IF ( topography /= 'flat' )  THEN
        action = ' '
-       IF ( scalar_advec /= 'pw-scheme' )  THEN
+       IF ( scalar_advec /= 'pw-scheme' .AND. scalar_advec /= 'ws-scheme')  THEN
           WRITE( action, '(A,A)' )  'scalar_advec = ', scalar_advec
        ENDIF
-       IF ( momentum_advec /= 'pw-scheme' )  THEN
+       IF ( momentum_advec /= 'pw-scheme' .AND. momentum_advec /= 'ws-scheme' ) &
+       THEN
           WRITE( action, '(A,A)' )  'momentum_advec = ', momentum_advec
        ENDIF
@@ -488,13 +490,4 @@
           CALL message( 'check_parameters', 'PA0014', 1, 2, 0, 6, 0 )
        ENDIF
-       IF ( momentum_advec == 'ws-scheme' .OR. scalar_advec == 'ws-scheme' ) &
-       THEN
-          message_string = 'topography is still not allowed with ' // &
-                           'momentum_advec = "' // TRIM( momentum_advec ) //  &
-                           '"or scalar_advec = "' // TRIM( scalar_advec ) //'"'
-   ! message number still needs modification
-           CALL message( 'check_parameters', 'PA0341', 1, 2, 0, 6, 0 )
-       END IF
-          
 !
 !--    In case of non-flat topography, check whether the convention how to 
@@ -739,5 +732,4 @@
     IF ( collision_kernel(6:9) == 'fast' )  use_kernel_tables = .TRUE.
 
-
     IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.  &
          TRIM( initializing_actions ) /= 'cyclic_fill' )  THEN
@@ -1406,12 +1398,4 @@
           CALL message( 'check_parameters', 'PA0053', 1, 2, 0, 6, 0 )
        ENDIF
-       IF ( (scalar_advec == 'ws-scheme' .OR. momentum_advec == 'ws-scheme' ) &
-          .AND. loop_optimization == 'vector' ) THEN
-          message_string = 'non-cyclic lateral boundaries do not allow ' // &
-                           'loop_optimization = vector and ' //  &
-                           'scalar_advec = "' // TRIM( scalar_advec ) // '"' 
-  ! The error message number still needs modification. 
-          CALL message( 'check_parameters', 'PA0342', 1, 2, 0, 6, 0 )
-       END IF
        IF ( galilei_transformation )  THEN
           message_string = 'non-cyclic lateral boundaries do not allow ' // &
Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 859)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 861)
@@ -4,4 +4,11 @@
 ! Current revisions:
 ! -----------------
+! Set wall_flags_0. The array is needed for degradation in ws-scheme near walls,
+! inflow and outflow boundaries as well as near the bottom and the top of the
+! model domain.
+!
+! Initialization of nzb_s_inner and nzb_w_inner.
+! gls has to be at least nbgp to do not exceed the array bounds of nzb_local
+! while setting wall_flags_0
 !
 ! Former revisions:
@@ -104,4 +111,6 @@
                                              corner_sr, wall_l, wall_n, wall_r,&
                                              wall_s, nzb_local, nzb_tmp
+
+    LOGICAL :: flag_set = .FALSE.
 
     REAL    ::  dx_l, dy_l, dz_stretched
@@ -311,4 +320,5 @@
 !-- the flag arrays needed for the multigrid method
     gls = 2**( maximum_grid_level )
+    IF ( gls < nbgp )  gls = nbgp
 
     ALLOCATE( corner_nl(nys:nyn,nxl:nxr), corner_nr(nys:nyn,nxl:nxr),       &
@@ -589,5 +599,8 @@
 
     END SELECT
-
+!
+!-- Determine the maximum level of topography. Furthermore it is used for
+!-- steering the degradation of order of the applied advection scheme.
+    nzb_max = MAXVAL( nzb_local )
 !
 !-- Consistency checks and index array initialization are only required for
@@ -653,6 +666,6 @@
 !
 !--    Initialize index arrays nzb_s_inner and nzb_w_inner
-       nzb_s_inner = nzb_local(nys-1:nyn+1,nxl-1:nxr+1)
-       nzb_w_inner = nzb_local(nys-1:nyn+1,nxl-1:nxr+1)
+       nzb_s_inner = nzb_local(nysg:nyng,nxlg:nxrg)
+       nzb_w_inner = nzb_local(nysg:nyng,nxlg:nxrg)
 
 !
@@ -1018,5 +1031,5 @@
                 ENDDO
              ENDDO
-          ENDDO 
+          ENDDO
 
 !
@@ -1036,4 +1049,219 @@
 
     ENDIF
+!
+!-- Allocate flags needed for masking walls.
+    ALLOCATE( wall_flags_0(nzb:nzt,nys:nyn,nxl:nxr) )
+    wall_flags_0 = 0
+
+    IF ( scalar_advec == 'ws-scheme' )  THEN
+!
+!--    Set flags to steer the degradation of the advection scheme in advec_ws
+!--    near topography, inflow- and outflow boundaries as well as bottom and
+!--    top of model domain. wall_flags_0 remains zero for all non-prognostic
+!--    grid points.
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt
+!
+!--             scalar - x-direction
+!--             WS1 (0), WS3 (1), WS5 (2)
+                IF ( k <= nzb_s_inner(j,i+1) .OR. ( outflow_l .AND. i == nxl ) &
+                     .OR. ( outflow_r .AND. i == nxr ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 0 )
+                ELSEIF ( k <= nzb_s_inner(j,i+2) .OR. k <= nzb_s_inner(j,i-1)  &
+                         .OR. ( outflow_r .AND. i == nxr-1 )                   &
+                         .OR. ( outflow_l .AND. i == nxlu  ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 1 )
+                ELSE
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 2 )
+                ENDIF
+!
+!--             scalar - y-direction
+!--             WS1 (3), WS3 (4), WS5 (5)
+                IF ( k <= nzb_s_inner(j+1,i) .OR. ( outflow_s .AND. j == nys ) &
+                     .OR. ( outflow_n .AND. j == nyn ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 3 )
+!--             WS3
+                ELSEIF ( k <= nzb_s_inner(j+2,i) .OR. k <= nzb_s_inner(j-1,i)  &
+                        .OR. ( outflow_s .AND. j == nysv )                     &
+                        .OR. ( outflow_n .AND. j == nyn-1  ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 4 )
+!--             WS5
+                ELSE
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 5 )
+                ENDIF
+!
+!--             scalar - z-direction
+!--             WS1 (6), WS3 (7), WS5 (8)
+                flag_set = .FALSE.
+                IF ( k == nzb_s_inner(j,i) + 1 .OR. k == nzt )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 6 )
+                   flag_set = .TRUE.
+                ELSEIF ( k == nzb_s_inner(j,i) + 2 .OR. k == nzt - 1 )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 7 )
+                   flag_set = .TRUE.
+                ELSEIF ( k > nzb_s_inner(j,i) .AND. .NOT. flag_set )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 8 )
+                ENDIF
+             ENDDO
+          ENDDO
+       ENDDO
+    ENDIF
+
+    IF ( momentum_advec == 'ws-scheme' )  THEN
+!
+!--    Set wall_flags_0 to steer the degradation of the advection scheme in advec_ws
+!--    near topography, inflow- and outflow boundaries as well as bottom and
+!--    top of model domain. wall_flags_0 remains zero for all non-prognostic
+!--    grid points.
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_u_inner(j,i)+1, nzt
+!
+!--             u component - x-direction
+!--             WS1 (9), WS3 (10), WS5 (11)
+                IF ( k <= nzb_u_inner(j,i+1)                                  &
+                     .OR. ( outflow_r .AND. i == nxr ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 9 )
+                ELSEIF ( k <= nzb_u_inner(j,i+2) .OR. k <= nzb_u_inner(j,i-1) &
+                         .OR. ( outflow_r .AND. i == nxr-1 )                  &
+                         .OR. ( outflow_l .AND. i == nxlu  ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 10 )
+                ELSE
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 11 )
+                ENDIF
+!
+!--             u component - y-direction
+!--             WS1 (12), WS3 (13), WS5 (14)
+                IF ( k <= nzb_u_inner(j+1,i) .OR. ( outflow_s .AND. j == nys ) &
+                    .OR. ( outflow_n .AND. j == nyn ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 12 )
+                ELSEIF ( k <= nzb_u_inner(j+2,i) .OR. k <= nzb_u_inner(j-1,i)  &
+                    .OR. ( outflow_s .AND. j == nysv )                         &
+                    .OR. ( outflow_n .AND. j == nyn-1  ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 13 )
+                ELSE
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 14 )
+                ENDIF
+!
+!--             u component - z-direction
+!--             WS1 (15), WS3 (16), WS5 (17)
+                flag_set = .FALSE.
+                IF ( k == nzb_u_inner(j,i) + 1 .OR. k == nzt )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 15 )
+                   flag_set = .TRUE.
+                ELSEIF ( k == nzb_u_inner(j,i) + 2 .OR. k == nzt - 1 )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 16 )
+                   flag_set = .TRUE.
+                ELSEIF ( k > nzb_u_inner(j,i) .AND. .NOT. flag_set )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 17 )
+                ENDIF
+
+             ENDDO
+          ENDDO
+       ENDDO
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_v_inner(j,i)+1, nzt
+!
+!--             v component - x-direction
+!--             WS1 (18), WS3 (19), WS5 (20)
+                IF ( k <= nzb_v_inner(j,i+1) .OR. ( outflow_l .AND. i == nxl ) &
+                    .OR. ( outflow_r .AND. i == nxr ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 18 )
+!--             WS3
+                ELSEIF ( k <= nzb_v_inner(j,i+2) .OR. k <= nzb_v_inner(j,i-1)  &
+                    .OR. ( outflow_r .AND. i == nxr-1 )                        &
+                    .OR. ( outflow_l .AND. i == nxlu  ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 19 )
+                ELSE
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 20 )
+                ENDIF
+!
+!--             v component - y-direction
+!--             WS1 (21), WS3 (22), WS5 (23)
+                IF ( k <= nzb_v_inner(j+1,i)                                   &
+                     .OR. ( outflow_n .AND. j == nyn ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 21 )
+                ELSEIF ( k <= nzb_v_inner(j+2,i) .OR. k <= nzb_v_inner(j-1,i)  &
+                         .OR. ( outflow_s .AND. j == nysv )                    &
+                         .OR. ( outflow_n .AND. j == nyn-1  ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 22 )
+                ELSE
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 23 )
+                ENDIF
+!
+!--             v component - z-direction
+!--             WS1 (24), WS3 (25), WS5 (26)
+                flag_set = .FALSE.
+                IF ( k == nzb_v_inner(j,i) + 1 .OR. k == nzt )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 24 )
+                   flag_set = .TRUE.
+                ELSEIF ( k == nzb_v_inner(j,i) + 2 .OR. k == nzt - 1 )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 25 )
+                   flag_set = .TRUE.
+                ELSEIF ( k > nzb_v_inner(j,i) .AND. .NOT. flag_set )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 26 )
+                ENDIF
+
+             ENDDO
+          ENDDO
+       ENDDO
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_w_inner(j,i)+1, nzt
+!
+!--             w component - x-direction
+!--             WS1 (27), WS3 (28), WS5 (29)
+                IF ( k <= nzb_w_inner(j,i+1) .OR. ( outflow_l .AND. i == nxl ) &
+                    .OR. ( outflow_r .AND. i == nxr ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 27 )
+                ELSEIF ( k <= nzb_w_inner(j,i+2) .OR. k <= nzb_w_inner(j,i-1)  &
+                         .OR. ( outflow_r .AND. i == nxr-1 )                   &
+                         .OR. ( outflow_l .AND. i == nxlu  ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 28 )
+                ELSE
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i),29 )
+                ENDIF
+!
+!--             w component - y-direction
+!--             WS1 (30), WS3 (31), WS5 (32)
+                IF ( k <= nzb_w_inner(j+1,i) .OR. ( outflow_s .AND. j == nys ) &
+                     .OR. ( outflow_n .AND. j == nyn ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 30 )
+                ELSEIF ( k <= nzb_w_inner(j+2,i) .OR. k <= nzb_w_inner(j-1,i)  &
+                         .OR. ( outflow_s .AND. j == nysv )                    &
+                         .OR. ( outflow_n .AND. j == nyn-1  ) )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 31 )
+                ELSE
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 32 )
+                ENDIF
+!
+!--             w component - z-direction
+!--             WS1 (33), WS3 (34), WS5 (35)
+                flag_set = .FALSE.
+                IF ( k == nzb_w_inner(j,i) .OR. k == nzb_w_inner(j,i) + 1      &
+                                           .OR. k == nzt )  THEN
+!
+!--                Please note, at k == nzb_w_inner(j,i) a flag is explictely
+!--                set, although this is not a prognostic level. However, 
+!--                contrary to the advection of u,v and s this is necessary
+!--                because flux_t(nzb_w_inner(j,i)) is used for the tendency
+!--                at k == nzb_w_inner(j,i)+1.
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 33 )
+                   flag_set = .TRUE.
+                ELSEIF ( k == nzb_w_inner(j,i) + 2 .OR. k == nzt - 1 )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 34 )
+                   flag_set = .TRUE.
+                ELSEIF ( k > nzb_w_inner(j,i) .AND. .NOT. flag_set )  THEN
+                   wall_flags_0(k,j,i) = IBSET( wall_flags_0(k,j,i), 35 )
+                ENDIF
+
+             ENDDO
+          ENDDO
+       ENDDO
+
+    ENDIF
 
 !
Index: palm/trunk/SOURCE/init_pt_anomaly.f90
===================================================================
--- palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 859)
+++ palm/trunk/SOURCE/init_pt_anomaly.f90	(revision 861)
@@ -4,4 +4,6 @@
 ! Current revisions:
 ! -----------------
+!
+! Modification of the amplitude to obtain a visible temperature perturbation. 
 !
 ! Former revisions:
@@ -62,5 +64,5 @@
              radius = SQRT( x**2 + y**2 + z**2 )
              IF ( radius <= rc )  THEN
-                betrag = 5.0 * EXP( -( radius / 2.0 )**2 )
+                betrag = 5.0 * EXP( -( radius * 0.001 / 2.0 )**2 )
              ELSE
                 betrag = 0.0
Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 859)
+++ palm/trunk/SOURCE/modules.f90	(revision 861)
@@ -4,5 +4,8 @@
 ! Current revisions:
 ! -----------------
-! 
+! +wall_flags_0
+! -boundary_flags
+! +nzb_max
+! +adv_sca_1, +adv_mom_1
 !
 ! Former revisions:
@@ -422,5 +425,5 @@
 
     REAL    ::  pi = 3.141592654
-    REAL    ::  adv_sca_5, adv_sca_3, adv_mom_5, adv_mom_3
+    REAL    ::  adv_mom_1, adv_mom_3, adv_mom_5, adv_sca_1, adv_sca_3, adv_sca_5
     
 
@@ -913,5 +916,5 @@
                 nxlu, nxr, nxra, nxrg, nx_on_file, nny, ny = 0, ny_a, ny_o,    &
                 nya, nyn, nyna, nyng, nys, nysg, nysv, ny_on_file, nnz, nz = 0,&
-                nza, nzb, nzb_diff, nzt, nzta, nzt_diff               
+                nza, nzb, nzb_diff, nzb_max, nzt, nzta, nzt_diff
 
 
@@ -923,16 +926,20 @@
 
 
-    INTEGER, DIMENSION(:,:), ALLOCATABLE :: boundary_flags,                    &
-                ngp_2dh_outer, ngp_2dh_s_inner, mg_loc_ind, nzb_diff_s_inner,  &
-                nzb_diff_s_outer, nzb_diff_u, nzb_diff_v, nzb_inner, nzb_outer,&
-                nzb_s_inner, nzb_s_outer, nzb_u_inner, nzb_u_outer,            &
-                nzb_v_inner, nzb_v_outer, nzb_w_inner, nzb_w_outer, nzb_2d
+    INTEGER, DIMENSION(:,:), ALLOCATABLE :: ngp_2dh_outer, ngp_2dh_s_inner,    &
+                mg_loc_ind, nzb_diff_s_inner, nzb_diff_s_outer, nzb_diff_u,    &
+                nzb_diff_v, nzb_inner, nzb_outer, nzb_s_inner, nzb_s_outer,    &
+                nzb_u_inner, nzb_u_outer, nzb_v_inner, nzb_v_outer,            &
+                nzb_w_inner, nzb_w_outer, nzb_2d
 
     INTEGER, DIMENSION(:,:,:), POINTER ::  flags
 
-    INTEGER, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  wall_flags_1,           &
-                wall_flags_2, wall_flags_3, wall_flags_4, wall_flags_5,        &
-                wall_flags_6, wall_flags_7, wall_flags_8, wall_flags_9,        &
-                wall_flags_10
+    INTEGER( KIND = SELECTED_INT_KIND(11) ), DIMENSION(:,:,:), ALLOCATABLE ::  &
+                wall_flags_0  ! need to have 34 Bit
+
+    INTEGER, DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::                         &
+                wall_flags_1, wall_flags_2, wall_flags_3, wall_flags_4,        &
+                wall_flags_5, wall_flags_6, wall_flags_7, wall_flags_8,        &
+                wall_flags_9, wall_flags_10
+
 
     SAVE
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 859)
+++ palm/trunk/SOURCE/palm.f90	(revision 861)
@@ -83,5 +83,5 @@
     INTEGER           ::  i, run_description_header_i(80)
 
-    version = 'PALM 3.8'
+    version = 'PALM 3.8a'
 
 #if defined( __parallel )
